program mpi_subprog

  use mpi

  implicit none

  integer myid, numprocs, rc, ierr, red_chk, red_chk_sum,rel_lng
  integer   ::         status(MPI_STATUS_SIZE)
  character (LEN=MPI_MAX_PROCESSOR_NAME) :: hostname
  real*8    ::         t1, t2
 
  call MPI_INIT( ierr )
  print *,'MPI_INIT return code: ',ierr
  call MPI_COMM_RANK( MPI_COMM_WORLD, myid, ierr )
  print *,'MPI_COMM_RANK return code: ',ierr
  call MPI_COMM_SIZE( MPI_COMM_WORLD, numprocs, ierr )
  print *,'MPI_COMM_SIZE return code: ',ierr
  call MPI_Get_processor_name(hostname, rel_lng, ierr)
  print *, 'Process ', myid, ' of ', numprocs, ' is alive - Hostname= ',hostname(1:index(hostname,".")-1)
 
!  call MPI_BARRIER(MPI_COMM_WORLD, rc)
!  print *,'MYID: ',myid,' MPI_BARRIER 1 RC= ',rc 

  red_chk_sum=0
  red_chk=10
  CALL MPI_REDUCE(red_chk, red_chk_sum, 1, MPI_INTEGER, MPI_SUM  &
                  ,0, MPI_COMM_WORLD, rc)
  print *,'MYID: ',myid,' MPI_REDUCE 1 red_chk_sum=',red_chk_sum,' rc=',rc

!    call MPI_BARRIER(MPI_COMM_WORLD, rc)
!    print *,'MYID: ',myid,' MPI_BARRIER 2 RC= ',rc 
      
 call MPI_FINALIZE(rc)
 stop
end




